import { AbstractTreeNode, CHECKED, UNCHECKED } from './abstract-node';
export class SingleTreeNode extends AbstractTreeNode {
    constructor(origin, getId, opts) {
        super(origin);
        Object.defineProperty(this, "getId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: getId
        });
        Object.defineProperty(this, "opts", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: opts
        });
        Object.defineProperty(this, "children", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_status", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_disabled", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this._id = getId(origin);
        this._disabled = !!(opts.disabled || origin.disabled);
        this._setUpChildren();
    }
    _setUpChildren() {
        if (this.origin.children) {
            this.children = this.origin.children.map((child) => {
                const node = new SingleTreeNode(child, this.getId, Object.assign(this.opts, {
                    disabled: this._disabled,
                }));
                node._setParent(this);
                return node;
            });
        }
    }
    _calculateStatus(checked) {
        this._status = this.id === checked ? CHECKED : UNCHECKED;
    }
}
